#include "Shadow.h"

#include <GL/gl.h>

#include "types.h"
#include "DisplayList.h"
#include "Light.h"

void generateShadowMatrix(ShadowMatrix sm, CGPoint3Df normal, CGPoint3Df point, CGPoint4Df light) {
	GLfloat d, dot;
	d = -normal[0]*point[0] - normal[1]*point[1] - normal[2]*point[2];
	dot = normal[0]*light[0]  + normal[1]*light[1] + normal[2]*light[2] + d*light[3];

	sm[0] = -light[0] * normal[0] + dot;
	sm[4] = -light[0] * normal[1];
	sm[8] = -light[0] * normal[2];
	sm[12] = -light[0] * d;
	sm[1] = -light[1] * normal[0];
	sm[5] = -light[1] * normal[1] + dot;
	sm[9] = -light[1] * normal[2];
	sm[13] = -light[1] * d;
	sm[2] = -light[2] * normal[0];
	sm[6] = -light[2] * normal[1];
	sm[10] = -light[2] * normal[2] + dot;
	sm[14] = -light[2] * d;
	sm[3] = -light[3] * normal[0];
	sm[7] = -light[3] * normal[1];
	sm[11] = -light[3] * normal[2];
	sm[15] = -light[3] * d + dot;
}
/*
void renderFloorAndShadows(DisplayList floor, PositionedLight light) {
	ShadowMatrix sm;
	glClear(GL_STENCIL_BUFFER_BIT);                 // Clear the stencil buffer the first time
	glEnable(GL_STENCIL_TEST);                      // Turn on the stencil buffer test


	glStencilFunc(GL_ALWAYS, 1, 1);               // Setup the stencil buffer to write
	glStencilOp(GL_KEEP, GL_KEEP, GL_REPLACE);    // a 1 everywhere the plane is.

	light->off();                        // Turn off the light
	glEnable(GL_TEXTURE_2D);
	floor->call();                // Render the surface into both the stencil and color buffer
	glDisable(GL_TEXTURE_2D);
	light->on();                        // Turn on the light

	glDisable(GL_DEPTH_TEST);
	glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);  // Disable the color buffer
	glStencilFunc(GL_EQUAL, 1, 1);                        // Set the stencil buffer to update
	glStencilOp(GL_KEEP, GL_KEEP, GL_INCR);               // only where it finds a 1 from the plane and increment the buffer

	// Go through all lights. Only one in this case
	glPushMatrix();
	  generateShadowMatrix( sm, roomNormal[surface], roomPoints[surface],
							LightPosition[0], LightPosition[1], LightPosition[2], LightPosition[3]);
	  glMultMatrixf(@ShadowMatrix[surface]);               // Add the shadow matrix to the ModelView

	  // Go through all objects. Two toruses
	  glPushMatrix();                                     // Render the shadow generators
		glTranslatef(Torus1Position[0], Torus1Position[1], Torus1Position[2]);
		glRotatef(ElapsedTime/8, 1, 0, 0);
		glRotatef(ElapsedTime/78, 0, 1, 0);
		glCallList(TorusDL[0]);
	  glPopMatrix();
	  glPushMatrix();                                     // Render the shadow generators
		glTranslatef(Torus2Position[0], Torus2Position[1], Torus2Position[2]);
		glRotatef(ElapsedTime/6, 1, 0, 0);
		glRotatef(ElapsedTime/58, 0, 1, 0);
		glCallList(TorusDL[1]);
	  glPopMatrix();
	glPopMatrix();

	glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);      // Turn the color buffer back on

	glEnable(GL_TEXTURE_2D);
	glCallList(roomDL[surface]);                          // Render the plane where ever this is a 1, denoting the plane is in full light
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_DEPTH_TEST);
	end;
	glDisable(GL_STENCIL_TEST);                             // Turn off the stencil test.

}
*/
