#ifndef UNITFORMS_H
#define UNITFORMS_H

/**
 * @file
 * Klassendeklaration fuer die Einheitsfiguren
 *
 * @author
 * Philip Lehmann-Boehm (minf8180)
 */

#include <GL/gl.h>

class UnitForms {
	public:

		/**
		 * Zeichnet ein Einheitsquadrat.
		 */
		static void drawUnitQuad();

		/**
		 * Zeichnet eine Einheitsscheibe.
		 * @param details Der Detailierungsgrad der Scheibe
		 */
		static void drawUnitDisk(int details);

		/**
		 * Zeichnet einen Einheitswuerfel
		 */
		static void drawUnitCube();

		/**
		 * Zeichnet eine Einheitskugel
		 * @param details Der Detailierungsgrad der Kugel
		 */
		static void UnitForms::drawUnitSphere(GLint details);

		/**
		 * Zeichnet eines Einheitskonus
		 * @param details Der Detailierungsgrad des Konusses
		 */
		static void drawUnitCone(GLint details);
};

#endif
