#ifndef WINDOW_H
#define WINDOW_H

/**
 * @file
 * Klassendeklaration fr das Clientfenster
 *
 * @author
 * Philip Lehmann-Boehm (minf8180)
 */

#include <QWidget>

#include "Logic.h"
#include "GLwidget.h"

class Window : public QWidget {
    Q_OBJECT
	public:

		/**
		 * Konstruktor
		 */
		Window();

		/**
		 * Destruktor
		 */
		~Window();

		/**
		 * Liefert, ob der Konstruktor komplett durchgelaufen ist.
		 * @return Ob der Konstruktor komplett durchgelaufen ist
		 */
		bool buildUp();

	private slots:

		/**
		 * Timerevent
		 */
		void timerFunc();

		/**
		 * Keyboardevent
		 * @param e Die Eventdaten
		 */
		void keyPressEvent (QKeyEvent * e);

	private:

		// Default-Port
		static const int defPort = 3333;

		// Die Einstellungsdatei
		static char * settingsXML;

		// Flag, ob der Konstruktor komplett durchgelaufen ist.
		bool buildUpFlag;

		// OpenGL-Widget
		GLWidget *glWidget;

		// Zeitmessung
		QTime * time;

		// Logik-Instanz
		Logic logic;

		// Timer
		QTimer *timer;
};

#endif
