#ifndef LIST_H__
#define LIST_H__ 1

/*--------------------*/

/* $Id: List.h,v 1.7 2006/01/08 14:20:08 uwe Exp $ */

#include <string.h>
#include "types.h"

typedef RadarPerson Element;

//#define eqElement(x,y) (strcmp((x),(y)) == 0)
//#define geElement(x,y) (strcmp((x),(y)) >= 0)

/*--------------------*/

typedef struct Node *List;

struct Node
{
    List next; /* alignment within structs */
    Element info; /* next is 1. field (!?) */
};

extern List mkEmptyList(void);
extern int isEmptyList(List l);
extern Element head(List l);
extern List tail(List l);

extern List removeHead(List l);

extern List cons(Element e, List l);

extern unsigned int length(List l);

extern Element at(List l,
                      unsigned int i);

extern int isInList(Element e, List l);

extern List insertElem(Element e,
                           List l);

extern List addElem(Element e, List l);

extern List removeElem(Element e,
                           List l);

extern List removeAllElems(Element e,
                               List l);

extern void freeList(List l);

/*--------------------*/
/* consistency check for sorted lists */

#define invList(l) 1

/*--------------------*/

#endif
