#ifndef TYPES_H
#define TYPES_H

/**
 * @file
 * Typdeklarationen
 *
 * @author
 * Philip Lehmann-Boehm (minf8180)
 * Christian Harendt (minf2964)
 */

#include <GL/gl.h>
#include <math.h>
#include <float.h>

// 3D-Vektor
typedef GLfloat CGPoint3Df[3];

// 4D-Vektor
typedef GLfloat CGPoint4Df[4];

// 3-Komponenten-Farbe
typedef GLfloat CGColor3f[3];

// 4-Komponenten-Farbe
typedef GLfloat CGColor4f[4];

// Eine Schattenmatrix
typedef GLfloat ShadowMatrix[15];

// Eine Person
typedef struct {
	float x;
	float y;
	float size;
} Person;

// Eine Person im RadarCache
typedef struct {
	float x;
	float y;
	bool hit;
} CachePerson;

// Eine Person in der Radarliste
class RadarPerson {
    public:
        float x;
        float y;
        float ttl; // TimeToLive is Opacity

        bool operator==(RadarPerson x) {
            return ((fabs(x.x - this->x) <= DBL_EPSILON) &&
                (fabs(x.y - this->y) <= DBL_EPSILON) &&
                (fabs(x.ttl - this->ttl) <= DBL_EPSILON));
        }
};

#endif
